bellman-ford AcWing 853. 有边数限制的最短路

bellman-ford AcWing 853. 有边数限制的最短路

原题链接

AcWing 853. 有边数限制的最短路

算法标签

最短路 Bellman-Ford

思路

由题意 存在负边, 因此不能采用Dijkstra
由于具有边数限制
故采用Bellman-Ford
Bellman-Ford算法
在这里插入图片描述

对于存在负权回路的路径
可能不存在最短路
例如下图
1至5最短路 不存在 由于每次在2, 3, 4回路中循环一次, 路几个长度减1
在这里插入图片描述

代码

#include<bits/stdc++.h>
#define int long long
#define rep(i, a, b) for(int i=a;i<b;++i)
#define Rep(i, a, b) for(int i=a;i>b;--i)
using namespace std;
const int N = 10005;
// p存储节点祖宗节点 d存储当前节点据祖宗节点的距离
int lst[N], dis[N];
int n,m,k;
inline int read(){
   int s=0,w=1;
   char ch=getchar();
   while(ch<'0'||ch>'9'){if(ch=='-')w=-1;ch=getchar();}
   while(ch>='0'&&ch<='9') s=s*10+ch-'0',ch=getchar();
   return s*w;
}
void put(int x) {
    if(x<0) putchar('-'),x=-x;
    if(x>=10) put(x/10);
    putchar(x%10^48);
}
struct Edge{
    int a, b, c;
}edge[N];
int be(){
    memset(dis, 0x3f3f, sizeof dis);
    dis[1]=0;
    rep(i, 0, k){
        memcpy(lst, dis, sizeof dis);
        rep(j, 0, m){
            Edge e=edge[j];
            dis[e.b]=min(dis[e.b], lst[e.a]+e.c);
        }
    }
    if(dis[n]>0x3f3f3f3f/2){
        return -1;
    }else{
        return dis[n];
    }
}
signed main(){
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    n=read(), m=read(), k=read();
    rep(i, 0, m){
        int x=read(), y=read(), z=read();
        edge[i]={x, y, z};
    }
    if(be()==-1){
        puts("impossible");
    }else{
        printf("%lld", dis[n]);
    }
    return 0;
}

原创不易
转载请标明出处
如果对你有所帮助 别忘啦点赞支持哈
在这里插入图片描述

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 打赏
    打赏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包

打赏作者

飞滕人生TYF

你的鼓励将是我创作的最大动力

¥1 ¥2 ¥4 ¥6 ¥10 ¥20
扫码支付:¥1
获取中
扫码支付

您的余额不足,请更换扫码支付或充值

打赏作者

实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值